plugin modifier KeyHydra_Preset_Chamfer
	name:"ChamferFix" category:"Keyhydra"
	classID:#(0x69b95491, 0x2871154a)
	extends:Chamfer
	replaceUI:off
(
	rollout presets "Preset Settings" rolledUp:on category:-1e3
	(
		button btnSavePreset "Save Current as Default" width:145 align:#center
		button btnResetToDefault "Revert to System Default" width:145 align:#center

		on btnSavePreset pressed do ::keyhydraUserSet.saveDefault "Chamfer" this.delegate
		on btnResetToDefault pressed do ::keyhydraUserSet.resetToDefault "Chamfer" this.delegate
	)

	on attachedToNode obj do
	(
		if ::keyhydraUserSet != undefined then
		(
			local oneUnit = units.decodeValue "1mm"

			delegate.segments = ::keyhydraUserSet.singleOrDefault "Chamfer" #segments 1
			delegate.amount = ::keyhydraUserSet.singleOrDefault "Chamfer" #amount oneUnit
			delegate.chamferType = ::keyhydraUserSet.singleOrDefault "Chamfer" #chamferType 0
			delegate.tension = ::keyhydraUserSet.singleOrDefault "Chamfer" #tension 0.5
			delegate.limitEffect = ::keyhydraUserSet.boolOrDefault "Chamfer" #limitEffect off
			delegate.useMinAngle = ::keyhydraUserSet.boolOrDefault "Chamfer" #useMinAngle off
			delegate.useMaxAngle = ::keyhydraUserSet.boolOrDefault "Chamfer" #useMaxAngle off
			delegate.smoothType = ::keyhydraUserSet.singleOrDefault "Chamfer" #smoothType 1
			delegate.smoothingOption = ::keyhydraUserSet.singleOrDefault "Chamfer" #smoothingOption 2
			delegate.smoothThreshold = ::keyhydraUserSet.singleOrDefault "Chamfer" #smoothThreshold 180
			delegate.smoothToAdjacent = ::keyhydraUserSet.boolOrDefault "Chamfer" #smoothToAdjacent on

			if (maxVersion())[1] >= 20000 do delegate.quadIntersectionMode = ::keyhydraUserSet.boolOrDefault "Chamfer" #quadIntersectionMode off
			if (maxVersion())[1] >= 22900 do
			(
				delegate.depth = ::keyhydraUserSet.singleOrDefault "Chamfer" #depth 0.5
				delegate.depthType = ::keyhydraUserSet.singleOrDefault "Chamfer" #depthType 0
				delegate.insetType = ::keyhydraUserSet.singleOrDefault "Chamfer" #insetType 0
				delegate.radiusBias = ::keyhydraUserSet.singleOrDefault "Chamfer" #radiusBias 0.0
				delegate.openChamfer = ::keyhydraUserSet.boolOrDefault "Chamfer" #openChamfer off
				delegate.invert = ::keyhydraUserSet.boolOrDefault "Chamfer" #invert off

				delegate.selectionOption = ::keyhydraUserSet.singleOrDefault "Chamfer" #selectionOption 0
				delegate.materialOption = ::keyhydraUserSet.singleOrDefault "Chamfer" #materialOption 0
				delegate.miteringType = ::keyhydraUserSet.singleOrDefault "Chamfer" #miteringType 2
				delegate.miterEndBias = ::keyhydraUserSet.singleOrDefault "Chamfer" #miterEndBias 0.5
				delegate.amountType = ::keyhydraUserSet.singleOrDefault "Chamfer" #amountType 0
				delegate.minAmount = ::keyhydraUserSet.singleOrDefault "Chamfer" #minAmount 0.0
				delegate.maxAmount = ::keyhydraUserSet.singleOrDefault "Chamfer" #maxAmount oneUnit

				delegate.addInset = ::keyhydraUserSet.boolOrDefault "Chamfer" #addInset off
				delegate.insetSegments = ::keyhydraUserSet.singleOrDefault "Chamfer" #insetSegments 0
				delegate.insetAmount = ::keyhydraUserSet.singleOrDefault "Chamfer" #insetAmount (oneUnit / 2d0)
				delegate.insetOffset = ::keyhydraUserSet.singleOrDefault "Chamfer" #insetOffset 0.0
				delegate.useConstantOffset = ::keyhydraUserSet.boolOrDefault "Chamfer" #useConstantOffset off
				delegate.forcePositiveOffset = ::keyhydraUserSet.boolOrDefault "Chamfer" #forcePositiveOffset off
			)
		)
		else messageBox "KeyHydra functions not loaded." title:"Error"
	)
)